# awesome_loader

A Dart plugin for using some Awesome Loaders in your application.

![Image](https://cdn-images-1.medium.com/max/800/1*f7cHwRcFmPWH0dRGQrGbxA.gif)

## Usage

To use this plugin, add `awesome_loader` as a 
[dependency in your pubspec.yaml file.](https://pub.dartlang.org/packages/awesome_loader#-installing-tab-)

It contains 4 animated loaders namely:
- AwesomeLoader1
- AwesomeLoader2
- AwesomeLoader3
- AwesomeLoader4

## Example

Below is the example of using `AwesomeLoader`

```dart
import 'package:flutter/material.dart';
import 'package:awesome_loader/awesome_loader.dart';

void main() => runApp(new MyApp());

class MyApp extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return new MaterialApp(
      title: 'Flutter Demo',
      home: Scaffold(
        body: Center(
          child: AwesomeLoader(
          ),
        ),
      ),
    );
  }
}
```

`AwesomeLoader()` accepts 2 optional parameters:
- loaderType : Pass this to change loader type.
- color : Pass this to change Loader Color.

Value of loaderType can be:
- AwesomeLoader.AwesomeLoader1
- AwesomeLoader.AwesomeLoader2
- AwesomeLoader.AwesomeLoader3
- AwesomeLoader.AwesomeLoader4

```dart
import 'package:flutter/material.dart';
import 'package:awesome_loader/awesome_loader.dart';

void main() => runApp(new MyApp());

class MyApp extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return new MaterialApp(
      title: 'Flutter Demo',
      home: Scaffold(
        body: Center(
          child: AwesomeLoader(
            loaderType: AwesomeLoader.AwesomeLoader2,
            color: Colors.blue,
          ),
        ),
      ),
    );
  }
}
```