import 'package:awesome_loader_null_safety/src/Loader1.dart';
import 'package:awesome_loader_null_safety/src/Loader2.dart';
import 'package:awesome_loader_null_safety/src/Loader3.dart';
import 'package:awesome_loader_null_safety/src/Loader4.dart';
import 'package:flutter/material.dart';

class AwesomeLoader extends StatelessWidget {
  static const int AwesomeLoader1 = 1;
  static const int AwesomeLoader2 = 2;
  static const int AwesomeLoader3 = 3;
  static const int AwesomeLoader4 = 4;

  final int? loaderType;
  final Color? color;

  const AwesomeLoader({Key? key, this.loaderType, this.color})
      : super(key: key);

  int? _getAnimationLoaderType() =>
      loaderType != null ? loaderType : AwesomeLoader1;

  Color? _getColor(BuildContext context) =>
      color != null ? color : Theme.of(context).colorScheme.secondary;

  @override
  Widget build(BuildContext context) {
    return Container(
      width: 50.0,
      height: 50.0,
      child: _getLoader(context),
    );
  }

  Widget _getLoader(BuildContext context) {
    switch (_getAnimationLoaderType()) {
      case AwesomeLoader1:
        return Loader1(
          color: _getColor(context),
        );

      case AwesomeLoader2:
        return Loader2(
          color: _getColor(context),
        );

      case AwesomeLoader3:
        return Loader3(
          color: _getColor(context),
        );

      case AwesomeLoader4:
        return Loader4(
          color: _getColor(context),
        );

      default:
        return Loader1(
          color: _getColor(context),
        );
    }
  }
}
