import 'package:awesome_loader_null_safety/src/Dot.dart';
import 'package:flutter/material.dart';

class Loader1 extends StatefulWidget {
  final Color? color;

  const Loader1({Key? key, this.color}) : super(key: key);

  @override
  _Loader1State createState() => _Loader1State();
}

class _Loader1State extends State<Loader1> with TickerProviderStateMixin {
  final double _maxValue = 20.0;
  double? _xValue, _xValue1;
  double? _yValue, _yValue1;

  late AnimationController _controller, _controller1;
  late Animation<double> _animationCircle1;
  late Animation<double> _animationCircle2;

  @override
  void initState() {
    super.initState();

    _controller =
        AnimationController(vsync: this, duration: Duration(milliseconds: 800));

    _controller1 =
        AnimationController(vsync: this, duration: Duration(milliseconds: 800));

    _animationCircle1 = Tween<double>(begin: -1.0, end: 1.0).animate(
        CurvedAnimation(
            parent: _controller,
            curve: Interval(0.0, 1.0, curve: Curves.ease)));

    _animationCircle2 = Tween<double>(begin: -1.0, end: 1.0).animate(
        CurvedAnimation(
            parent: _controller1,
            curve: Interval(0.0, 1.0, curve: Curves.ease)));

    _controller.addListener(() {
      setState(() {
        if (_controller.value >= 0.0 && _controller.value <= 1.0) {
          _xValue = _maxValue * _animationCircle1.value;
          _yValue = _xValue;
        }
      });
    });

    _controller1.addListener(() {
      setState(() {
        if (_controller1.value >= 0.0 && _controller1.value <= 1.0) {
          _xValue1 = _maxValue * _animationCircle2.value;
          _yValue1 = -_xValue1!;
        }
      });
    });

    _controller.addStatusListener((status) {
      if (status == AnimationStatus.completed) {
        _controller.reverse();
      } else if (status == AnimationStatus.dismissed) {
        _controller.forward();
      }
    });

    _controller1.addStatusListener((status) {
      if (status == AnimationStatus.completed) {
        _controller1.reverse();
      } else if (status == AnimationStatus.dismissed) {
        _controller1.forward();
      }
    });

    _controller1.forward(from: 0.5);
    _controller.forward();
  }

  @override
  void dispose() {
    _controller.dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return Center(
      child: Stack(
        children: <Widget>[
          Dot(
            radious: 20.0,
            color: widget.color,
          ),
          Transform.translate(
            offset: Offset(_xValue!, _yValue!),
            child: Dot(
              radious: 12.0,
              color: widget.color,
            ),
          ),
          Transform.translate(
            offset: Offset(_xValue1!, _yValue1!),
            child: Dot(
              radious: 12.0,
              color: widget.color,
            ),
          ),
        ],
      ),
    );
  }
}
