import 'package:awesome_loader_null_safety/src/Dot.dart';
import 'package:flutter/material.dart';

class Loader4 extends StatefulWidget {
  final Color? color;

  const Loader4({Key? key, this.color}) : super(key: key);

  @override
  _Loader4State createState() => _Loader4State();
}

class _Loader4State extends State<Loader4> with SingleTickerProviderStateMixin {
  late AnimationController _controller;
  late Animation<double> _movement;
  double yAxis = 0.0;
  double _maxHeight = 10.0;

  @override
  void initState() {
    // TODO: implement initState
    super.initState();
    _controller =
        AnimationController(vsync: this, duration: Duration(milliseconds: 850));

    _movement = TweenSequence(<TweenSequenceItem<double>>[
      TweenSequenceItem<double>(
          tween: Tween<double>(begin: -1.0, end: 1.0)
              .chain(CurveTween(curve: Curves.easeIn)),
          weight: 50.0),
      TweenSequenceItem<double>(
          tween: Tween<double>(begin: 1.0, end: -1.0)
              .chain(CurveTween(curve: Curves.easeIn)),
          weight: 50.0),
    ]).animate(CurvedAnimation(parent: _controller, curve: Interval(0.0, 1.0)));

    _controller.addListener(() {
      setState(() {
        yAxis = _movement.value * _maxHeight;
      });
    });

    _controller.repeat();
  }

  @override
  void dispose() {
    // TODO: implement dispose
    _controller.dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return Center(
      child: Stack(
        children: <Widget>[
          Transform.translate(
            offset: Offset(-20.0, yAxis),
            child: Dot(
              radious: 10.0,
              color: widget.color,
            ),
          ),
          Transform.translate(
            offset: Offset(0.0, -yAxis),
            child: Dot(
              radious: 10.0,
              color: widget.color,
            ),
          ),
          Transform.translate(
            offset: Offset(20.0, yAxis),
            child: Dot(
              radious: 10.0,
              color: widget.color,
            ),
          ),
        ],
      ),
    );
  }
}
